% Voir livre Perron et Munger: Analyse des systèmes et matrice d'état et exercices multi-physiques 2022 
% REMARQUE AU LECTEUR: LE MODÈLE SUGGÉRÉ EST UN EXEMPLE ACCADÉMIQUE.  
% TOUTES AUTRES APPLICATIONS EST AU RISQUE DE L'UTILISATEUR

% Problème : Le monte-charge
close all, clear all , clc

%% Paramètres du problème
m = 1000;                           % Masse [kg]
B = 1000;                           % Coefficient de friction [Ns/m]
g = 9.81;                           % Acceleration gravitationnelle [m/s^2]
F = 0;                              % Force de traction [N]

%% Question 1 : Trouver l'equation d'etat
% syms a1 a2 b1 b2 B m
a1 = B/m;
b1 = 1/m;

matA = [0 1;0 -a1];                 % Matrice d'etat
matB = [0 0;-b1 1];                 % Matrice de controle

%% Question 2 : Trouver le resolvant phi(s)
syms s

I = eye(2); % Matrice identite
Phi = inv(s*I-matA); % Resolvant

%% Question 3 : Trouver les fonctions de transfert G1(s) = v/F et G2(s) = v/g
C = [0 1];  % Vecteur d'observation de la vitesse
Gvs = C*Phi*matB; % Fonctions de transfert
Gv1s = Gvs(1); % v/F
Gv2s = Gvs(2); % v/g

%% Question 4 : Trouver v(t) et v(inf)
syms t %g

Us = [F/s ; g/s]; % Vecteur de controle

vs = Gv2s*Us(2);     % v(s)
vt = ilaplace(vs,t); % v(t) [m/s]

time = linspace(0,15,10000); % Vecteur temps [s]
vtAffichage = subs(vt,t,time);

figure (1)
hold on
plot(time,vtAffichage)
xlabel('Temps (s)')
ylabel('Vitesse (m/s)')
title('Évolution de la vitesse du monte-charge (F=0)')
grid on
hold off