% Voir livre Perron et Munger: Analyse des systèmes et matrice d'état et exercices multi-physiques 2022 
% REMARQUE AU LECTEUR: LE MODÈLE SUGGÉRÉ EST UN EXEMPLE ACCADÉMIQUE.  
% TOUTES AUTRES APPLICATIONS EST AU RISQUE DE L'UTILISATEUR

% Problème : La voiture de course en virage
close all , clear all , clc

%% Paramètres du problème
alpha = 0.9;                        % Fraction de la poussée maxime du moteur [-]
C0 = 0.5;                           % Coefficient force de poussée [kg/m]
C1 = 1.783;                         % Coefficient force de traînée [kg/m]
Fm = 7154;                          % Force de poussée maximale [N]
g = 9.81;                           % Accélération gravitationnelle [m/s2]
m = 500;                            % Masse [kg]
N = m*g;                            % Force normale [N]
r = 1000;                           % Rayon de braquage [m]
mus1 = 0.05;                        % Coefficient de frottement statique direction S [-]
mus2 = 0.637;                       % Coefficient de frottement statique direction R [-]
vmoy = 41.67;                       % Vitesse moyenne [m/s]

%% Question 3 : Trouver l'equation d'etat
% syms a1 b1 b2 g C1 vmoy m Fm
a1 = -C1*vmoy/m;
b1 = Fm/m;
b2 = -g;

matA = [0 1;0 a1];                  % Matrice d'etat
matB = [0 0;b1 b2];                 % Matrice de controle

%% Question 4 : Trouver le resolvant phi(s)
syms s t

I = eye(2);                         % Matrice identite
Phi = inv(s*I-matA);                % Resolvant

%% Question 5 : Trouver x(t) et v(t)
% syms alpha mus1
u = [alpha/s;mus1/s];               % Vecteur d'entrées
Cobs1 = [1 0];                      % Vecteur d'observation de la position
xS = Cobs1*Phi*matB*u;              % x(s)
xT = ilaplace(xS,t);                % x(t) 
vT = diff(xT,t);                    % v(t)

%% Question 6 : Trouver x(10) et v(10)
x10 = subs(xT,t,10);
v10 = subs(vT,t,10);

time = linspace(0,50,1000); % Vecteur temps [s]
xTAff = subs(xT,t,time);
vTAff = subs(vT,t,time);

figure (1)
hold on
plot(time,xTAff)
xlabel('Temps (s)')
ylabel('Position (m)')
title('Évolution de la position de la voiture')
grid on
hold off

figure (2)
hold on
plot(time,vTAff)
xlabel('Temps (s)')
ylabel('Vitesse (m/s)')
title('Évolution de la vitesse de la voiture')
grid on
hold off

%% Question 7 : Quelle est la vitesse maximale de la voiture
t = inf;
alpha = 1;
vMax = (Fm*alpha - g*m*mus1)/(C1*vmoy) - (exp(-(C1*t*vmoy)/m)*...
    (Fm*alpha - g*m*mus1))/(C1*vmoy);

%% Question 8 : Condition de glissement
vAvecAileron = sqrt((mus2*m*g/((m/r)-(mus2*C0))));
vSansAileron = sqrt((mus2*m*g/(m/r)));
