% Voir livre Perron et Munger: Analyse des systèmes et matrice d'état et exercices multi-physiques 2022 
% REMARQUE AU LECTEUR: LE MODÈLE SUGGÉRÉ EST UN EXEMPLE ACCADÉMIQUE.  
% TOUTES AUTRES APPLICATIONS EST AU RISQUE DE L'UTILISATEUR

% Problème : Rendez-vous spatial
close all , clear all , clc

%% Parametres du probleme
m = 80000;                                  % Masse [kg]
vitesseNavette = 7800;                      % Vitesse de la navette [m/s]
vitesseStation = 7700;                      % Vitesse de la station [m/s]
positionStation = 1e6;                      % Position de la station [m]
Fm = 53000;                                 % Force maximale [N]

%% Question 1 : Trouver l'equation d'etat
% syms a1 b1 Fm m
b1 = -Fm/m;

matA = [0 1;0 0];    % Matrice d'etat
matB = [0 ; b1];     % Matrice de controle

%% Question 2 : Trouver le resolvant phi(s)
syms s 

I = eye(2);          % Matrice identite
Phi = inv(s*I-matA); % Resolvant

%% Question 3 : Trouver la fonction de transfert G1s = x/alpha
C = [1 0];           % Vecteur d'observation de la position
G = C*Phi*matB;      % Fonctions de transfert
G1s = G(1);          % x/alpha

%% Question 4 : Trouver x(t) et v(t)
syms t

alpha = 0.5/s;          % Condition du probleme

positionS = [1,0]*Phi*([0;vitesseNavette]+matB*alpha);
positionT = ilaplace(positionS,t);          % x(t) [m]

vitesseS = [0,1]*Phi*([0;vitesseNavette]+matB*alpha); 
vitesseT = ilaplace(vitesseS,t);            % v(t) [m/s]

%% Question 7 : Quel est le temps necessaire pour le rendez-vous a 1 km
alphaT = exp(-sqrt(Fm/(m*10^6))*t) ; 
S = solve(alphaT==1000/10^6,t);

%% Question 8 : Est-ce qu'il y aura assez de carburant?
time = linspace(0,8500,100000); % Vecteur temps [s]
alphaTAff =  exp(-sqrt(Fm/(m*10^6)).*time);

carburant = int(alphaT,t,0,S) ; % Aire sous la courbe de la poussée

syms x
figure (1)
hold on
fplot(heaviside(x), [0, 1250])
plot(time,alphaTAff,'--')
line([1250 1250], [0 1],'color',[0, 0.4470, 0.7410]);% Ajoute la ligne verticale bleue
xlim([0 9000])
ylim([0 1.2])
xlabel('Temps (s)')
ylabel('Fraction de poussée')
title('Évolution de la poussée en fonction du temps')
legend('Poussée maximale constante','Fonction décroissante de la poussée')
grid on
hold off