% Voir livre Perron et Munger: Analyse des systèmes et matrice d'état et exercices multi-physiques 2022 
% REMARQUE AU LECTEUR: LE MODÈLE SUGGÉRÉ EST UN EXEMPLE ACCADÉMIQUE.  
% TOUTES AUTRES APPLICATIONS EST AU RISQUE DE L'UTILISATEUR

% Problème : Régulation de la vitesse adaptative avec radar
close all , clear all , clc

%% Parametres du probleme
Cmax = 561;     % Couple maximal [Nm]
M = 2490;       % Masse de la voiture [kg]
R = 0.3;        % Rayon des roues [m]
g = 9.81;       % Accélération gravitationnelle [m/s^2]
uR = 0.015;     % Coefficient de friction [-]
K1 = 0.04;      % Constante [s/m]
K2 = 0.00075;   % Constante [m^-1]
Vs = 100/3.6;   % Vitesse constante [m/s]
Vmax = 200/3.6; % Vitesse maximale avec conversion km/h -> m/s
A =  (Cmax/(R*M));
%%
%%%%%%% PARTIE A %%%%%%%

%% Question 2 : Trouver la valeur de K si Vmax = 200 km/h
K = Cmax/(R*Vmax)-uR*g*M/Vmax;

%% Question 1 : Trouver l'equation d'etat
syms a b1 b2 %uR K M Vmax Cmax g R
a = -K/M;
b1 = Cmax/(R*M);
b2 = -g;

matA = [0 1;0 a]; % Matrice d'etat
matB = [0 0 ;b1 b2]; % Matrice de controle

%% Question 3 : Trouver le résolvant Phi
syms s t
I = eye(2); % Matrice identite
Phi = inv(s*I-matA); % Resolvant

%% Question 4 : Trouver les fonctions de transferts G1=x/alpha et G2=v/alpha
C1 = [1 0]; % Matrice d'observation de la position
C2 = [0 1]; % Matrice d'observation de la vitesse

G1 = C1*Phi*matB; % [x/alpha x/uR]
G2 = C2*Phi*matB; % [v/alpha v/uR]

G1Alpha = G1(1); % [x/alpha]
G2Alpha = G2(1); % [v/alpha]

%% Question 5 : Trouver les pôles, les systèmes est-il stable?
num1 = [b1];
den1 = [1 -a 0];

G1FonctionTransfert = tf(num1,den1);
P = pole(G1FonctionTransfert);
Z = zero(G1FonctionTransfert);

figure (1)
hold on
pzmap(G1FonctionTransfert)
grid on
hold off

%% Question 6 : Trouver l'expression de x(t)
syms alpha uR
U = [alpha/s; uR/s];

matA = [0 1;0 a]; % Matrice d'etat
matB = [0 0 ;b1 b2]; % Matrice de controle
Phi = inv(s*I-matA); % Resolvant

positionS = C1*Phi*matB*U;
positionT = ilaplace(positionS,t);

%% Question 7 : Trouver l'expression de v(t)
vitesseS = C2*Phi*matB*U;
vitesseT = ilaplace(vitesseS,t);

%% Question 8 : Tracer x(t) et v(t) pour alpha = 1 
time  = linspace(0,350,1000); % Vecteur temps [s]

alphaT = 1 ;
uRT = 0.015;

temp = subs(positionT,alpha,alphaT);
temp2 = subs(temp,uR,uRT);
positionTaff = subs(temp2,t,time);

temp = subs(vitesseT,alpha,alphaT);
temp2 = subs(temp,uR,uRT);
vitesseTaff = subs(temp2,t,time);

 
figure(2)
hold on
plot(time,positionTaff)
grid on
xlabel('Temps (s)')
ylabel('Position (m)')
axis([0 350 0 16000])
title('Position de la voiture en boucle ouverte')
hold off

figure(3)
hold on
plot(time,vitesseTaff)
grid on
xlabel('Temps (s)')
ylabel('Vitesse (m/s)')
title('Vitesse de la voiture en boucle ouverte')
hold off

%%
%%%%%%% PARTIE C %%%%%%%
%% Faire simuler le Simulink avant d'utiliser cette partie
% figure(4)
% hold on
% plot(out.Temps,out.Positions(1:end,2))
% plot(out.Temps,out.Positions(1:end,1),'--')
% grid on
% xlabel('Temps (s)')
% ylabel('Position (m)')
% title('Positions des voitures en boucle fermée')
% legend('Voiture à vitesse constante', 'Voiture à vitesse adaptative')
% hold off
% 
% figure(5)
% hold on
% plot(out.Temps,out.Vitesses(1:end,2))
% plot(out.Temps,out.Vitesses(1:end,1),'--')
% grid on
% xlabel('Temps (s)')
% ylabel('Vitesse (m/s)')
% title('Vitesses des voitures en boucle fermée')
% legend('Voiture à vitesse constante', 'Voiture à vitesse adaptative')
% hold off
% 
% figure(6)
% hold on
% plot(out.Temps,out.PositionXsX)
% grid on
% xlabel('Temps (s)')
% ylabel('Position (m)')
% title('Différence de position en boucle fermée')
% hold off
% 
% figure(7)
% hold on
% plot(out.Temps,out.Alpha)
% grid on
% xlabel('Temps (s)')
% ylabel('Fraction du couple maximal \alpha (-)')
% title('Fraction du couple maximal \alpha en boucle fermée')
% hold off