% Voir livre Perron et Munger: Analyse des systèmes et matrice d'état et exercices multi-physiques 2022 
% REMARQUE AU LECTEUR: LE MODÈLE SUGGÉRÉ EST UN EXEMPLE ACCADÉMIQUE.  
% TOUTES AUTRES APPLICATIONS EST AU RISQUE DE L'UTILISATEUR

% Problème : Caméra suiveuse de lignes
close all , clear all , clc

%% Parametres du probleme
m = 1000 ;  % Masse de la voiture [kg]
Fm = 2000 ; % Force motrice maximale [N]

%%
%%%%%%% PARTIE A %%%%%%%
%% Question 4  : Trouver Cf
Vmax = 200/3.6; % Vitesse maximale [m/s]
Cf = Fm/Vmax ;  % Coefficient de friction de l'air

%% Question 1 : Trouver l'equation d'etat
syms a b1 b2 Fm m Cf
% a = -Cf/m;
% b1 = Fm/m;
% b2 = 1/m;

matA = [0 1 0 0 ;0 0 0 0;0 0 0 1 ; 0 0 0 a]; % Matrice d'etat
matB = [0 0 0 0;b1 0 b2 0;0 0 0 0; 0  b1 0 b2]; % Matrice de controle

%% Question 2 : Trouver le résolvant et G1(s), G2(s), G3(s), G4(s)
syms s t
I = eye(4); % Matrice identite
Phi = inv(s*I-matA); % Resolvant
C1 = [1 0 0 0]; % Matrice observation x
C3 = [0 0 1 0]; % Matrice observation y

Gx = C1*Phi*matB; % Fonctions de transfert de x
Gy = C3*Phi*matB; % Fonctions de transfert de y

G1 = Gx(1); % x/alphasinbeta
G2 = Gx(3); % x/Fpx
G3 = Gy(2); % y/alphacosbeta
G4 = Gy(4); % y/Fpy

G1TF = tf(b1,[1 0 0]);
G2TF = tf(b2,[1 0 0]);
G3TF = tf(b1,[1 -a 0]);
G4TF = tf(b2,[1 -a 0]);

%% Question 3 : Trouver x(t) et y(t)
syms x0 vx0 y0 vy0 alphaCosBeta alphaSinBeta Fpx Fpy
% x0=0; vx0=0; y0=0; vy0=0; % Conditions initiales
% alphaCosBeta = 1*cos(0);
% alphaSinBeta = 1*sin(0);
% Fpx = 0 ; % Force de pertubation latérale [N]
% Fpy = 0 ; % Force de perturbation avant y [N]

u = [alphaSinBeta/s; alphaCosBeta/s; Fpx/s; Fpy/s]; % Entrées échelons
CI = [x0; vx0; y0; vy0]; % Conditions initiales
xS = C1*Phi*(CI+matB*u); % x(s)
xT = ilaplace(xS,t); % x(t)
yS = C3*Phi*(CI+matB*u); % y(t)
yT = ilaplace(yS,t); % y(t)
vyT = diff(yT,t); % v(t) 

%% Question 5 ; Tracer y(t) et v(t) pour 60 [s]
time = linspace(0,60,1000); % Vecteur temps
yTaff = subs(yT,t,time);
vyTaff = subs(vyT,t,time);

figure (1)
hold on
plot(time,yTaff)
xlabel('Temps (s)')
ylabel('Position (m)')
title('Évolution de l''avance de la voiture (boucle ouverte)')
grid on
hold off

figure (2)
hold on
plot(time,vyTaff)
xlabel('Temps (s)')
ylabel('Vitesse (m/s)')
title('Évolution de la vitesse de la voiture (boucle ouverte)')
grid on
hold off

%% Question 6 : Trouver G5(s)
syms K1
K1 = 0.1; % Compensateur proportionnel
G5 = (K1*G1)/(1+(K1*G1));

GcTF = tf(K1); % Fonction de transfert du controleur
G5TF = feedback(G1TF*GcTF,1); % Fonction de transfert en boucle fermée

%% Question 7 : Trouver x(t) avec G5(s)
%syms Fpx XR0
XR0 = 1; % Distance [m];
xS = G5*XR0/s + G2*Fpx/s; % x(s)
xT = ilaplace(xS,t); % x(t)
vT = diff(xT,t); % v(t)

XRs = tf(XR0,[1 0]); % Entrée échelon
FpxTF = tf(Fpx,[1 0]);
xSTF = G5TF*XRs + G2TF*FpxTF; % x(s)

%% Question 8 : Tracer x(t) (Faire rouler Simulink avant)
% figure (3)
% hold on
% plot(out.clk,out.Position1)
% xlabel('Temps (s)')
% ylabel('Position (m)') 
% title('Évolution de la trajectoire de la voiture en boucle fermée')
% legend('Route','Voiture')
% grid on
% hold off

p = pole(xSTF); % Détermine les pôles du système
z = zero(xSTF); % Détermine les zéros du système

figure(4) 
hold on
pzmap(p,z) % Trace les poles-zeros du système
grid on
hold off

%% Question 9 : Trouver G6 avec Gc : PI
syms K4 K1 tau
K1 = 0.1;
K4 = 0.00375;
tau = 0.1;

Gc = K1+K4/(tau*s); % Gc(s)
G6 = (Gc*G1)/(1+(Gc*G1)); %G6(s)

GcTF = tf([tau*K1 K4],[tau 0]); % Compensateur PI
G6TF = feedback(GcTF*G1TF,1);

%% Question 10 : Trouver x(t) avec G6(s)
xSTF = G6TF*XRs + G2TF*Fpx;
p = pole(xSTF);
z = zero(xSTF);

figure (4)
hold on
pzmap(xSTF)
grid on
hold off

%% Question 12 : Tracer x(t) et X-Xr (Faire rouler Simulink avant)
% figure (4)
% hold on
% plot(out.clk,out.Position2)
% xlabel('Temps (s)')
% ylabel('Position (m)') 
% title('Évolution de la trajectoire de la voiture en boucle fermée')
% legend('Route','Voiture')
% grid on
% hold off
% 
% figure (5)
% hold on
% plot(out.clk,out.XXr2)
% xlabel('Temps (s)')
% ylabel('Position (m)')
% title('Écart de position de la voiture en boucle fermée')
% grid on
% hold off

%% Question 14 : Trouver x(s) avec G6 et xR = 50sin(pi*t/10)+xR0
syms t xR0
xRT = 50*sin(pi*t/10)+xR0;
xRS = laplace(xRT,t);
xS = G6*xRS;
xT = ilaplace(xS,t);

%% Question 16 : Tracer x(t) et X-Xr (Faire rouler Simulink avant)
% figure (6)
% hold on
% plot(out.clk,out.Position3)
% xlabel('Temps (s)')
% ylabel('Position (m)') 
% title('Évolution de la trajectoire de la voiture en boucle fermée')
% legend('Route','Voiture')
% grid on
% hold off
% 
% figure (7)
% hold on
% plot(out.clk,out.XXr3)
% xlabel('Temps (s)')
% ylabel('Position (m)')
% title('Écart de position de la voiture en boucle fermée')
% grid on
% hold off
